/* DISK.H--
 * Copyright (c) 2004 Hjort Nidudsson
 *
 * Change history:
 * 04 Apr 2004	- Created
 */
#ifndef __INC_DISK
#define __INC_DISK
#if !defined(__INC_DEFS)
 #include <defs.h>
#endif

#ifdef __cplusplus
 extern "C" {
#endif

#define _DISK_NOSUCHDRIVE	0	/* _bios_disktype() */
#define _DISK_FLOPPYNOCHAIN	1
#define _DISK_FLOPPYWIDTHCHAIN	2
#define _DISK_HARDDRIVE		3

#define _DISK_LOCAL	0x0001		/* _dos_remotedevice() */
#define _DISK_FLOPPY	0x0100
#define _DISK_NETWORK	0x0200
#define _DISK_SUBST	0x0400
#define _DISK_CDROOM	0x0800

/*  __drv:  (00h = A:, 01h = B:, ...)
 *  __disk: (00h = default, 01h = A:, ...)
 */
int _CType getdrv(void);
int _CType chdrv(int __drv);

int _CType _disk_type(int __drv);
int _CType _disk_init(int __drv);
int _CType _disk_test(int __drv);
int _CType _disk_ready(int __drv);
int _CType _disk_retry(int __drv);
int _CType _disk_select(const char *);

unsigned long _CType getdrvmap(void);
int _CType _dos_remotedevice(int __disk);
int _CType _bios_disktype(int __drv);

#ifdef __cplusplus
 }
#endif
#endif